/*	Author:		Amal Alsuwaidan
	Supervisor: 	Dr. Ryan Leduc
	

	Project submitted to the Department of Computing and Software of McMaster University
	in partial fulfilment of the requirements for the degree of M.A.Sc in Software Engineering
	2012 - 2015	
*/
#pragma once
#include <QList>
#include "Des.h"
#include "DesFlatProject.h"
#include "FlatDummyProject.h"


namespace DESpot
{	
	class DefaultFTAlgo : public DesAlgo
	{
	public:
		DefaultFTAlgo(const DesProject& currentProject, QList<QString>& currentFaultSet);
		~DefaultFTAlgo();
		bool runAlgo();
		void constructGF();
		void constructGFTimed();
		void createDummyFlatProject();
		void addGF();
		bool verifyFTCtrl();
		bool isDFTControllable() const; 

	protected:
		Des* GFDes;
		const DesProject& m_currentProject;
		DesFlatProject* m_flatDummyProject;
		QList<QString> m_faultSet;
	private:
		bool m_isDFTControllable;
	};
}
