/*************************************************************************
 * This file is part of the Distributed Computation feature
 *
 * Project created in conformity with the requirements for the Degree of
 * Master of Engineering in Software Engineering, Computing and Software
 * Department, McMaster University 2012
 *
 * Author:	David Kirby
 * Supervisor: Dr. Ryan Leduc
 *
 * Description: This class handles the Distributed Configuration pop up menu.
 ************************************************************************/
#pragma once

#include <QDialog>
#include <QFileDialog>

#include "CommonDefinitions.h"
#include "ui_DistributedConfigDialog.h"

#include "HostFileManager.h"

#include <string>

namespace DESpot
{
	class DistributedConfigDialog : public QDialog, private Ui::DistributedConfigDialog
	{
		Q_OBJECT	
		
		public:
			DistributedConfigDialog(QWidget* parent = null);
			~DistributedConfigDialog(void);

		//Overridables
		protected:
			virtual void accept();

		private:
			void fillNodeBox();
	};

} //end of namespace DESpot
