/*	Author:		Amal Alsuwaidan
	Supervisor: 	Dr. Ryan Leduc
	

	Project submitted to the Department of Computing and Software of McMaster University
	in partial fulfilment of the requirements for the degree of M.A.Sc in Software Engineering
	2012 - 2015	
*/

#pragma once
#include "DefaultFTAlgo.h"
#include <QMultiMap>
#include <QList>

namespace DESpot
{	
	class ResetFTAlgo : public  DefaultFTAlgo
	{
	public:
		ResetFTAlgo(const DesProject& currentProject, QList<QString>& faultSet ,int M , QMultiMap<int, QString>& faultSets, QMultiMap<int, QString>& resetSets);
		~ResetFTAlgo();
		bool runAlgo();
		void constructGTFi();
		void addGTFi(Des* GTFiDes);
		bool verifyFTCtrl();
		bool isResetFaultsControllable() const;

	protected:
		int m_M;
		QMultiMap<int, QString>& m_faultSets;
		QMultiMap<int, QString>& m_resetSets;

	private:
		bool m_isResetFaultsControllable;
	};
}
